<?php

class actionUcartIndex extends cmsAction {
	
	public function run(){

		$user = cmsUser::getInstance();

		$errors = $item = false;

		$form = $this->getForm('order');

		$form->addFieldset();
 
		$form_fields = $this->model->orderBy('ordering', 'desc')->getBuyer(false, true);

		foreach ($form_fields as $key => $value) {
			$field_options = array('title' => $value['title']);
			if($value['is_required']){
				$field_options['rules'] = array(array('required'));
				$field_options['options']['is_required'] = 1;
			}
			if(!empty($value['hint'])){
				$field_options['hint'] = $value['hint'];
			}
			if(strtolower($value['title']) == 'email'){
				$field_options['rules'][1] =  array('email');
			}
			if ($user->id) {
				if (isset($user->$value['name'])) {
					$field_options['default'] = $user->$value['name'];
				}
			}
			$form->addFieldToBeginning(false, new fieldString('field_'.$value['id'], $field_options));
		}

		if (!empty($this->options['required_text'])) {
			if (!empty($this->options['required_link'])) {
				$text = '<a href='.$this->options['required_link'].' target="_blank">'.$this->options['required_text'].'</a>';
			} else {
				$text = $this->options['required_text'];
			}
			$field_options['title'] = $text;
			$field_options['rules'] = array(array('required'));
			$form->addField(false, new fieldCheckbox('field_required', $field_options));
		}
		
		$is_submitted = $this->request->has('submit');
       
		if ($is_submitted){
			
            $item = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $item);
			
			if (!$errors){

				$item = array();
				$core = cmsCore::getInstance();
				$items = $core->request->getAll();

				if(isset($items['field_required'])) { unset($items['field_required']); }

				foreach ($items as $key => $value) {
					if(strpos($key, 'field_') === false) continue;
					$key = str_replace('field_', '', $key);
					$item[$key] = $value;
				}
				$hash = $this->sendOrderForm($item);

				cmsEventsManager::hook("order_after_add", $hash);
            
				$this->redirectToAction('ok', $hash);
				
			}
			
			if ($errors){
				
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
				
			}
        
		}

		$items = $this->model->getCartItems($user->id);

		$ratio = $this->model->getRatio(false, 2);
		$delivery = $this->model->getDelivery(false, true);
		$delivery = array_collection_to_list($delivery, 'id', 'title');

		$delivery_id = $user->isSessionSet('delivery') ? $user->sessionGet('delivery') : false;
		
		$template = cmsTemplate::getInstance();
		$template->render('index', array(
			'items' => $items,
			'ratio' => $ratio,
			'delivery' => $delivery,
			'delivery_id' => $delivery_id,
			'form' => $form,
			'item' => $item,
			'errors' => $errors
		));
		
	}
	
}
