<?php

class actionUcartDeliveryEdit extends cmsAction {

    public function run($id){
		
		$errors = false;
		
		$form = $this->getForm('delivery');
		
		$is_submitted = $this->request->has('submit');
		
		$delivery = $this->model->getDelivery($id);
        
		if ($is_submitted){
			
            $delivery = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $delivery);
			
			if (!$errors){
				
				$this->model->updateDelivery($id, $delivery);
            
				$this->redirectToAction('delivery');
				
			}
			
			if ($errors){
				
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
				
			}
        
		}
		
        return cmsTemplate::getInstance()->render('backend/delivery_edit', array(
            'form' => $form,
			'errors' => $errors,
			'delivery' => $delivery
        ));

    }

}
