<?php

class actionUcartRatioEdit extends cmsAction {

    public function run($id){
		
		$errors = false;
		
		$is_submitted = $this->request->has('submit');
		
		$ratio = $this->model->getRatio($id);

		$form = $this->getForm('ratio', array($ratio));
        
		if ($is_submitted){
			
            $ratio = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $ratio);
			
			if (!$errors){
				
				$this->model->updateRatio($id, $ratio);
            
				$this->redirectToAction('ratio');
				
			}
			
			if ($errors){
				
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
				
			}
        
		}
		
        return cmsTemplate::getInstance()->render('backend/ratio_edit', array(
            'form' => $form,
			'errors' => $errors,
			'ratio' => $ratio
        ));

    }

}
