<?php

function grid_order($controller){

    $options = array(
        'is_sortable' => false,
        'order_by' => 'id',
        'order_to' => 'desc',
        'is_pagination' => true,
        'is_draggable' => false,
    );

    $columns = array(
    	'id' => array(
    		'title' => '#',
    		'filter' => 'exact',
    		'width' => 30,
    		'handler' => function ($field){
				return '<a href="'.href_to('ucart', 'order', $field).'">'.$field.'</a>';
			}
    	),
    	'user_id' => array(
            'title' => 'Польз.',
            'width' => 50,
			'filter' => 'exact',
			'handler' => function ($field){
				if ($field) {
					$model = cmsCore::getModel('users');
					$user = $model->getUser($field);
					$item = '<a href="'.href_to('users', $user['id']).'">'.$user['nickname'].'</a>';
				} else {
					$item = 'Гость';
				}
				return $item;
			}
        ),
        'summ_items' => array(
    		'title' => 'Сумма',
    		'filter' => 'exact',
    		'width' => 30,
    	),
    	'amount' => array(
    		'title' => 'Оплачено',
    		'filter' => 'exact',
    		'width' => 30
    	),
    	'buyer' => array(
    		'title' => 'О покупателе',
    		'filter' => 'like',
    		'handler' => function ($field){
    			$buyer = false;
    			foreach ($field as $key => $value) {
    				if(is_array($value['title'])) $value['title'] = array_shift($value['title']);
    				$buyer .= '<div style="font-size:12px;"><font color="cadetblue">'.$value['title'].'</font>: <b>'.$value['value'].'</b></div>';
    			}
    			return $buyer;
    		}
    	),
    	'items' => array(
    		'title' => 'Заказ',
    		'filter' => 'like',
    		'handler' => function ($field){
    			$item = '';
    			foreach ($field as $key => $values) {
    				
    				$item .= '<div style="font-size:12px;font-weight:bold;"><a href="'.href_to($values['ctype_name'],$values['item']['slug'].'.html').'">'.$values['item']['title'].'</a></div>';

    				if (!empty($values['prop_value'])) {
    					foreach ($values['prop_value'] as $value_prop) {
							$item .= '<div style="font-size:12px;">'.$value_prop['title'].': '.$value_prop['value'].'</div>';
						}
					}

					$item .= '<div style="font-size:12px;">Количество: '.$values['items_count'].'</div>';

    			}
    			return $item;
    		}
    	),
    	'delivery' => array(
            'title' => 'Доставка',
			'filter' => 'exact',
			'handler' => function ($field){
    			return $field['title'];
			}
        ),
        'date_pub' => array(
            'title' => 'Дата заказа',
			'width' => 50,
			'filter' => 'date',
			'handler' => function ($field){
				return html_date($field, true);
			}
        ),
        'status' => array(
    		'title' => 'Статус',
    		'filter' => 'exact',
    		'width' => 30,
    		'handler' => function ($field){
    			$status = cmsCore::getModel('ucart')->getStatus($field);
    			if($status)
					return $status['title'];
				else
					return $field;
			}
    	),

    );

    $actions = array(
    	array(
            'title' => 'Изменить',
            'class' => 'edit',
            'href' => href_to('admin', 'controllers', array('edit', 'ucart', 'order_edit', '{id}')),
        ),
        array(
            'title' => LANG_DELETE,
            'class' => 'delete',
            'confirm' => 'Удалить заказ?',
            'href' => href_to('admin', 'controllers', array('edit', 'ucart', 'order_delete', '{id}')),
        )
    );

    return array(
        'options' => $options,
        'columns' => $columns,
        'actions' => $actions
    );

}
