<?php

function grid_ratio($controller){

    $options = array(
        'is_sortable' => false,
        'order_by' => 'ordering',
        'order_to' => 'asc',
        'is_pagination' => false,
        'is_filter' => false,
        'is_draggable' => true,
        'show_id' => false
    );

    $columns = array(
    	'id' => array(
            'title' => 'ID',
        ),
        'title' => array(
            'title' => 'Название коэффициента',
        ),
		'description' => array(
            'title' => 'Описание',
        ),
        'type' => array(
            'title' => 'Тип',
            'handler' => function($value) {
            	switch ($value) {
            		case 1: $item = 'На товар'; break;
            		case 2: $item = 'На заказ'; break;
            	}
            	return $item;
            }
        ),
        'unit' => array(
            'title' => 'Единицы',
            'handler' => function($value) {
            	switch ($value) {
            		case 1: $item = '%'; break;
            		case 2: $item = 'Сумма'; break;
            	}
            	return $item;
            }
        ),
        'value' => array(
            'title' => 'Кол-во',
        ),
        'min_amount' => array(
            'title' => 'Мин.сумма заказа',
        ),
        'max_amount' => array(
            'title' => 'Макс.сумма заказа',
        ),
        'ctype_title' => array(
            'title' => 'Тип контента',
        ),
        'category_title' => array(
            'title' => 'Категория',
        ),
		'is_enabled' => array(
            'title' => 'Активен',
			'flag' => true,
			'flag_toggle' => href_to($controller->root_url, 'toggle', array('{id}', 'ratio'))
        ),
        'name' => array(
            'title' => 'Сист.имя',
        ),
    );

    $actions = array(
        array(
            'title' => LANG_CONFIG,
            'class' => 'config',
            'href' => href_to('admin', 'controllers', array('edit', 'ucart', 'ratio_edit', '{id}')),
        ),
        array(
            'title' => LANG_DELETE,
            'class' => 'delete',
            'confirm' => 'Удалить коэффициент?',
            'href' => href_to('admin', 'controllers', array('edit', 'ucart', 'ratio_delete', '{id}')),
        )
    );

    return array(
        'options' => $options,
        'columns' => $columns,
        'actions' => $actions
    );

}
