<?php

class modelUcart extends cmsModel {
	
	public function addCart($ctype_id, $item_id, $user_id, $count, $props=false){

		$bin_id = !$user_id ? self::getBinId() : null;

		$item = array(
			'ctype_id' => $ctype_id,
			'item_id' => $item_id,
			'user_id' => $user_id,
			'session_id' => $bin_id,
			'items_count' => $count,
			'props' => $props
		);

		return $this->insert('ucart', $item);

	}

	public function getCartItems($user_id) {

		if($user_id){
		$this->filterStart();
		$this->filterEqual('user_id', $user_id);
		$this->filterEnd();
		$this->filterOr();
		}
		$this->filterStart();
		$this->filterEqual('session_id', self::getBinId());
		$this->filterEnd();

		$this->join('content_types', 'c', 'c.id = i.ctype_id');
		$this->select('c.name', 'ctype_name');

		return $this->get('ucart', function($item, $model){

			$cm = cmsCore::getModel('content');
			$item['item'] = $cm->getContentItem($item['ctype_name'], $item['item_id']);
			$ctype = $cm->getContentTypeByName($item['ctype_name']);
			$item['item'] = $model->handlerItemRatio($ctype, $item['item']);
			$item['item'] = array_shift($item['item']);
			$item['category'] = $cm->getCategory($item['ctype_name'], $item['item']['category_id']);

			if (!empty($item['props'])) {
				$item['prop_value'] = $model->getPropValueByCart($item);
			}

			if (!empty($item['prop_value'])) {
				foreach ($item['prop_value'] as $value_prop) {
					if (!empty($value_prop['ratio'])) {
						if($value_prop['unit'] == 'percent') { //если проценты
		            		$item['item']['price'] = $item['item']['price']+($item['item']['price']*($value_prop['ratio']/100));
		            	} else if ($value_prop['unit'] == 'value') { //иначе
		            		$item['item']['price'] += $value_prop['ratio'];
		            	}
		            }
				}
			}

			return $item;

		});

	}

	public function getItemCart($ctype_id, $item_id, $user_id) {

		if($user_id){
		$this->filterStart();
		$this->filterEqual('user_id', $user_id);
		$this->filterEqual('ctype_id', $ctype_id);
		$this->filterEqual('item_id', $item_id);
		$this->filterEnd();
		$this->filterOr();
		}
		$this->filterStart();
		$this->filterEqual('session_id', self::getBinId());
		$this->filterEqual('ctype_id', $ctype_id);
		$this->filterEqual('item_id', $item_id);
		$this->filterEnd();

		return $this->getItem('ucart');

	}

	public function getCartCount($user_id) {

		if($user_id){
		$this->filterStart();
		$this->filterEqual('user_id', $user_id);
		$this->filterEnd();
		$this->filterOr();
		}
		$this->filterStart();
		$this->filterEqual('session_id', self::getBinId());
		$this->filterEnd();

		return $this->getCount('ucart');

	}

	public function addCartCount($id, $count){

		$this->resetFilters();
		$this->filterEqual('id', $id);

		return $this->increment('ucart', 'items_count', $count);

	}

	public function delItemCart($id){

		return $this->delete('ucart', $id);

	}

	public function updateItemCartCount($id, $count) {

		return $this->update('ucart', $id, array('items_count'=>$count));

	}

	public function getDelivery($id=false, $is_enabled=false){
		
		if($id)
			return $this->getItemById('ucart_delivery', $id);

		if ($is_enabled)
			$this->filterEqual('is_enabled', 1);
		
		$this->orderBy('ordering');
		
		return $this->get('ucart_delivery');
		
	}
	
	public function getDeliveryCount(){
		
		return $this->getCount('ucart_delivery');
		
	}

	public function addDelivery($item){
		
		return $this->insert('ucart_delivery', $item);
		
	}
	
	public function deleteDelivery($id){
		
		return $this->delete('ucart_delivery', $id);
		
	}
	
	public function updateDelivery($id, $item){
		
		return $this->update('ucart_delivery', $id, $item);
		
	}

	public function getRatio($id=false, $type=false){
		
		if ($id)
			return $this->getItemById('ucart_ratio', $id);

		if ($type)
			$this->filterEqual('type', $type);

		$this->orderBy('ordering');
		
		return $this->get('ucart_ratio', function($item, $model){

			if($item['type'] != 1){
				$item['ctype_title'] = 'Весь заказ';
				$item['ctype_name'] = 'Весь заказ';
				$item['category_title'] = 'Весь заказ';
				return $item;
			}

			$content_model = cmsCore::getModel('content');

			$ctype = $content_model->getContentType($item['ctype_id']);
			$category = $content_model->getCategory($ctype['name'], $item['category_id']);

			$item['ctype_title'] = $ctype['title'];
			$item['ctype_name'] = $ctype['name'];
			$item['category_title'] = $category['title'];

			return $item;

		});
		
	}
	
	public function getRatioCount(){
		
		return $this->getCount('ucart_ratio');
		
	}

	public function addRatio($item){
		
		return $this->insert('ucart_ratio', $item);
		
	}
	
	public function deleteRatio($id){
		
		return $this->delete('ucart_ratio', $id);
		
	}
	
	public function updateRatio($id, $item){
		
		return $this->update('ucart_ratio', $id, $item);
		
	}

	public function handlerItemRatio($ctype, $item, $fields=false){

		$controller = cmsCore::getController('ucart');

		if(empty($ctype['ratio'])) 
			$ratio = $this->getRatio(false, 1);
		else
			$ratio = $ctype['ratio'];

		$ratio = cmsEventsManager::hook('before_item_ratio', $ratio);

		if ($ratio) {

			//p-процент, u-значение
			$p_bonus = $s_bonus = 0;

			foreach($ratio as $value){

				if($value['is_enabled']!=1)
					continue; //Если выключено пропускаем

				if($value['ctype_id'] != $ctype['id'])
					continue; //Если не тот тип контента пропускаем

				if(!empty($value['category_id'])){
					if($value['category_id'] != $item['category_id'] && $value['category_id'] != '1'){
						continue; //Если не та категория пропускаем
					}
				}
				
				if($value['unit'] == 1) {
					$p_bonus += $value['value'];
				} else {
					$s_bonus += $value['value'];
				}

			}

			if($p_bonus!=false && $p_bonus!=0) {
				$item['price'] = $item['price']+($item['price']*($p_bonus/100));
			}

			if($s_bonus!=false && $s_bonus!=0) {
				$item['price'] = $item['price']+$s_bonus;
			}

			$item['price'] = round($item['price'], 2);

			if($fields){
				$fields['price']['html'] = $item['price'].' '.$controller->options['val'];
				$fields['price']['handler']->item['price'] = $item['price'];
			}

		}

		return array($item, $fields);

	}

	public function getBuyer($id=false, $is_enabled=false){
		
		if($id)
			return $this->getItemById('ucart_buyer', $id);

		if ($is_enabled)
			$this->filterEqual('is_enabled', 1);
		
		return $this->get('ucart_buyer');
		
	}
	
	public function getBuyerCount(){
		
		return $this->getCount('ucart_buyer');
		
	}

	public function addBuyer($item){
		
		return $this->insert('ucart_buyer', $item);
		
	}
	
	public function deleteBuyer($id){
		
		return $this->delete('ucart_buyer', $id);
		
	}
	
	public function updateBuyer($id, $item){
		
		return $this->update('ucart_buyer', $id, $item);
		
	}

	public function addOrder($order){

		return $this->insert('ucart_orders', $order);

	}

	public function getOrderByHash($hash){

		$this->filterEqual('hash', $hash);

		$order = $this->getItem('ucart_orders');

		$order['user'] = cmsModel::yamlToArray($order['user']);
		$order['buyer'] = cmsModel::yamlToArray($order['buyer']);
		$order['items'] = cmsModel::yamlToArray($order['items']);
		$order['ratio'] = cmsModel::yamlToArray($order['ratio']);
		$order['delivery'] = cmsModel::yamlToArray($order['delivery']);

		$order['status_details'] = $this->getStatus($order['status']);

		return $order;

	}

	public function clearBin($user_id) {

		$this->resetFilters();
		$this->filterStart();
		$this->filterEqual('user_id', $user_id);
		$this->filterEnd();
		$this->filterOr();
		$this->filterStart();
		$this->filterEqual('session_id', self::getBinId());
		$this->filterEnd();

		return $this->deleteFiltered('ucart');

	}

	public function getOrder(){
		
		return $this->get('ucart_orders', function($item, $model){

			$item['user'] = cmsModel::yamlToArray($item['user']);
			$item['buyer'] = cmsModel::yamlToArray($item['buyer']);
			$item['items'] = cmsModel::yamlToArray($item['items']);
			$item['ratio'] = cmsModel::yamlToArray($item['ratio']);
			$item['delivery'] = cmsModel::yamlToArray($item['delivery']);

			$item['status_details'] = $model->getStatus($item['status']);

			return $item;

		});
		
	}

	public function getOrderById($id){
		
		$order = $this->getItemById('ucart_orders', $id);

		if(!$order){ return false; }

		$order['user'] = cmsModel::yamlToArray($order['user']);
		$order['buyer'] = cmsModel::yamlToArray($order['buyer']);
		$order['items'] = cmsModel::yamlToArray($order['items']);
		$order['ratio'] = cmsModel::yamlToArray($order['ratio']);
		$order['delivery'] = cmsModel::yamlToArray($order['delivery']);

		$order['status_details'] = $this->getStatus($order['status']);

		return $order;
		
	}

	public function updateOrder($id, $item){
		
		return $this->update('ucart_orders', $id, $item);
		
	}
	
	public function getOrderCount(){
		
		return $this->getCount('ucart_orders');
		
	}

	public function deleteOrder($id){
		
		return $this->delete('ucart_orders', $id);
		
	}

	public function getBinId() {

		return cmsCore::getController('ucart')->getBinId();

	}

	public function updateUserBin($user_id) {

		$bin_id = self::getBinId();

		$this->resetFilters();
		$this->filterEqual('session_id', $bin_id);
		$this->filterNotEqual('user_id', $user_id);

		return $this->updateFiltered('ucart', array('user_id'=>$user_id, 'session_id'=>null));

	}

	public function updateUserOrder($user_id) {

		$bin_id = self::getBinId();

		$this->resetFilters();
		$this->filterEqual('session_id', $bin_id);
		$this->filterNotEqual('user_id', $user_id);

		return $this->updateFiltered('ucart_orders', array('user_id'=>$user_id, 'session_id'=>null));

	}

	public function incrementOrderAmount($order_id, $amount) {

		$this->resetFilters();
		$this->filterEqual('id', $order_id);

		return $this->increment('ucart_orders', 'amount', $amount);

	}

	public function getStatus($id=false){
		
		if($id)
			return $this->getItemById('ucart_status', $id);
		
		return $this->get('ucart_status');
		
	}
	
	public function getStatusCount(){
		
		return $this->getCount('ucart_status');
		
	}

	public function addStatus($item){
		
		return $this->insert('ucart_status', $item);
		
	}

	public function updateStatus($id, $item){
		
		return $this->update('ucart_status', $id, $item);
		
	}

	public function deleteStatus($id){
		
		return $this->delete('ucart_status', $id);
		
	}

	public function getPropValueByCart($item){

		$content_model = cmsCore::getModel('content');

		$ctype = $content_model->getContentType($item['ctype_id']);

		if (!$ctype) { return false; }

		$content_item = $content_model->getContentItem($ctype['name'], $item['item_id']);

		if (!$content_item) { return false; }

		$fields = $content_model->getContentFields($ctype['name'], $item['item_id']);

		$item['props'] = cmsModel::yamlToArray($item['props']);

		foreach ($item['props'] as $key => $value) {

			foreach ($fields as $key2 => $value2) {
				
				if ($value2['type'] != 'ucartprops') { continue; }

				$props = $content_item[$key2];

				if (empty($props)) { continue; }

				$props = cmsModel::yamlToArray($props);

				if(!isset($props[$value['name']])) { continue; }

				$items[$key]['title'] = $props[$value['name']]['title'];
				$items[$key]['value'] = $props[$value['name']]['prop'][$value['val']]['name'];
				$items[$key]['ratio'] = $props[$value['name']]['prop'][$value['val']]['ratio'];
				$items[$key]['unit'] = $props[$value['name']]['prop'][$value['val']]['unit'];

				break;

			}

		}

		return $items;

	}
	
}
