<?php

class fieldUcartsticker extends cmsFormField {

    public $title       = 'Стикеры';
    public $sql         = 'varchar(32) NULL DEFAULT NULL';
    public $filter_type = 'str';
    public $var_type    = 'string';

    public function getOptions(){
        return array(
            new fieldText('stickers', array(
                'title' => 'Стикеры',
                'default' => false
            )),
        );
    }

    public function parse($value){

    	$stickers = $this->getOption('stickers', '');

    	if (empty($stickers) || $value == 'NULL' || empty($value)) { return ''; };

    	$items = string_explode_list($stickers);

    	if(empty($items[$value])) { return ''; }

    	$items = explode('#', $items[$value]);

    	$title = $items[0];
    	$color = $value;

    	if (empty($items[1]))
    		$value = '<span class="ucart_sticker" style="background:'.$color.';">'.$title.'</span>';
    	else
    		$value = '<a title="Подробнее..." href="'.$items[1].'" target="_blank" class="ucart_sticker" style="background:'.$color.';">'.$title.'</a>';

        return $value;

    }

    public function getInput($value){

    	$stickers = $this->getOption('stickers', '');

    	if (empty($stickers)) { return ''; };

    	$items = string_explode_list($stickers);

    	foreach ($items as $key => $values) {
    		$values = explode('#', $values);
    		$items[$key] = $values[0];
    	}
        
		return '<label for="'.$this->id.'">'.$this->title.'</label>'.html_select($this->name, $items, $value);
    
    }

    public function getFilterInput($value){

    	$stickers = $this->getOption('stickers', '');

    	if (empty($stickers)) { return ''; };

    	$items = string_explode_list($stickers);

    	foreach ($items as $key => $values) {
    		$values = explode('#', $values);
    		$items[$key] = $values[0];
    	}
        
		return html_select($this->name, $items, $value);
    
    }

    public function applyFilter($model, $value) {

        return $model->filterEqual($this->name, $value);

    }

}
