<?php

	$this->addControllerCSS('styles', 'ucart');
	$this->addControllerJS('script', 'ucart');
	$this->addJS('templates/default/js/jquery-ui.js');
    
    $this->setPageTitle('Корзина покупателя');
    $this->addBreadcrumb('Корзина покупателя');

?>
<div class="ucart_index responsive_table">


<h1>Корзина</h1>

<?php if ($items) { ?>
	
<table class="bin_t">
    <thead>
	<tr>
		<th colspan="2" class="th_title">Наименование</th>
		<th width="250" class="th_cat mob_hidden">Категория</th>
		<th width="100" class="mob_hidden">Количество</th>
		<th width="50" class="th_price">Цена</th>
		<th width="20"></th>
	</tr>
	</thead>
	
	<tbody>
	
	<?php foreach ($items as $key => $value) { ?>
	<tr class="bin_item bin_t_tr bin_t_<?php echo $value['id']; ?> bin_t_tr_item">
		<td width="80" align="center" class="item_image">
			<a href="<?php echo href_to($value['ctype_name'], $value['item']['slug'].'.html'); ?>">
				<?php echo html_avatar_image($value['item']['photo'], 'small', $value['item']['title'], true); ?>
			</a>
		</td>
		<td class="bin_title">
			<a href="<?php echo href_to($value['ctype_name'], $value['item']['slug'].'.html'); ?>">
				<?php echo $value['item']['title']; ?>
			</a>
			<?php if (!empty($value['prop_value'])) { ?>
				<?php foreach ($value['prop_value'] as $value_prop) { ?>
					<div class="prop">
						<?php echo $value_prop['title']; ?>: <span class="prop_value"><?php echo $value_prop['value']; ?></span>
						<?php if(!empty($value_prop['ratio'])){ ?>
							<?php if($value_prop['unit'] == 'percent'){ //если проценты ?>
		            			(<?php echo html_signed_num($value_prop['ratio']); ?>%)
		            		<?php } else if ($value_prop['unit'] == 'value') { //иначе ?>
		            			(<?php echo html_signed_num($value_prop['ratio']).$this->controller->options['val']; ?>)
		            		<?php } ?>
		            	<?php } ?>
					</div>
				<?php } ?>
			<?php } ?>
		</td>
		<td class="bin_cats"><a href="<?php echo href_to($value['ctype_name'], $value['category']['slug']); ?>"><?php echo $value['category']['title']; ?></a></td>
		<td class="td_item_price"><span class="item_price" style="display:none"><?php echo $value['item']['price']; ?></span><?php echo html_input('text', 'count', $value['items_count'], array('class'=>'bin_t_count', 'data-id'=>$value['id'])); ?></td>
		<td class="bin_t_price items_list" data-id="<?php echo $value['id']; ?>" align="center"></td>
		<td align="center" class="tr_t_del"><span class="bin_t_del bin_t_<?php echo $value['id']; ?>" data-id="<?php echo $value['id']; ?>" title="Удалить"></span></td>
	</tr>
	<?php } ?>
	
	<?php if($ratio) { ?>
		<?php foreach ($ratio as $key => $value) { ?>
		<?php if (!$value['is_enabled']) continue; ?>
			<tr class="bin_t_tr bin_t_<?php echo $value['id']; ?>">
				<td></td>
				<td class="bin_td_ratio">
					<?php echo $value['title']; ?>, <?php echo $value['unit'] == 2 ? $this->controller->options['val'] : $value['value'].'%'; ?>
				</td>
				<td></td>
				<td></td>
				<td class="ratio_item" data-ratio-min="<?php echo $value['min_amount']; ?>" data-ratio-max="<?php echo $value['max_amount']; ?>" data-ratio-value="<?php echo $value['value']; ?>" data-ratio-unit="<?php echo $value['unit']; ?>" align="center">0</td>
				<td></td>
			</tr>
		<? } ?>
	<?php } ?>

	<tr class="tr_deliv bin_t_tr bin_t_<?php echo $value['id']; ?>">
		<td width="80"></td>
		<td class="bin_td_deliv">Способ доставки</td>
		<td align="center"><?php echo html_select('delivery', $delivery, $delivery_id, array('id'=>'deliv_list')); ?></td>
		<td class="td_item_price"></td>
		<td class="bin_t_price_deliv" align="center">0</td>
		<td></td>
	</tr>
	<tr class="tr_price_result">
		<td colspan="6" align="right">Итого: <span id="price-result">0</span> <?php echo $this->controller->options['val']; ?></td>
	</tr>

	</tbody>

</table>

<div class="text-before-form"><?php echo $this->controller->options['order_before_form']; ?></div>

<div class="bin_form">
<?php $this->renderForm($form, $item, array(		
		'action' => '',
		'method' => 'post',
		'toolbar' => false,
		'submit' => array(
            'title' => 'Отправить заказ'
        ),
	), $errors); ?>
</div>

<p class="hidden_zero zero-bin-text"><?php echo $this->controller->options['no_bin_text']; ?></p>

<?php } else { ?>

<p class="zero-bin-text"><?php echo $this->controller->options['no_bin_text']; ?></p>

<?php } ?>

</div>